![gli](/src/main/resources/logo-mini.png)

This is the Kotlin port of the original [OpenGL Image](http://gli.g-truc.net/) (*GLI*), a header only C++ image library for graphics software.

*GLI* provides classes and functions to load image files (*[KTX](https://www.khronos.org/opengles/sdk/tools/KTX/)* and *[DDS](https://msdn.microsoft.com/en-us/library/windows/desktop/bb943990%28v=vs.85%29.aspx)*), facilitate graphics APIs texture creation, compare textures, access texture texels, sample textures, convert textures, generate mipmaps, etc.

This library works perfectly with *[OpenGL](https://www.opengl.org)* or *[Vulkan](https://www.khronos.org/vulkan)* but it also ensures interoperability with other third party libraries and SDK.
It is a good candidate for software rendering (raytracing / rasterisation), image processing, image based software testing or any development context that requires a simple and convenient image library.

[comment]: <> (For more information about *GLI*, please have a look at the [manual](manual.md\) and the [API reference documentation](http://gli.g-truc.net/0.8.0/api/index.html\).)
[comment]: <> (The source code and the documentation are licensed under the [Happy Bunny License (Modified MIT\) or the MIT License](manual.md#section0\).)

Don't hesitate to contribute to the project by submitting [issues](https://github.com/kotlin-graphics/gli/issues) or [pull requests](https://github.com/kotlin-graphics/gli/pulls) for bugs and features. Any feedback is welcome at [elect86@gmail.com](mailto://elect86@gmail.com).
